#define __PROG_TYPES_COMPAT__

#define F_CPU			16000000

#include <avr/pgmspace.h>
#include <avr/io.h>
#define __DELAY_BACKWARD_COMPATIBLE__
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <util/delay.h>

#include "lcd/spi.h"
#include "lcd/ST7735R_TFT.h"
#include "mpu6050/mpu6050.h"
#include "i2chw/i2cmaster.h"
#define __PROG_TYPES_COMPAT__
#define SPEED 1
#define bls 8

#define max(a,b) \
({ __typeof__ (a) _a = (a); \
   __typeof__ (b) _b = (b); \
 _a > _b ? _a : _b; })

#define min(a,b) \
({ __typeof__ (a) _a = (a); \
   __typeof__ (b) _b = (b); \
 _a < _b ? _a : _b; })

int mat[ST7735R_WIDTH / bls][ST7735R_HEIGHT / bls];

void bar(int x, int y, int py) {
	int i;
	while (py < y) {
		ST7735R_FillRect(min(ST7735R_WIDTH - 1, max(0, x)), min(ST7735R_HEIGHT - 1, max(0, py)), min(ST7735R_WIDTH - 1, max(0, x + bls)), min(ST7735R_HEIGHT - 1, max(0, py + bls)), 0, 0, 0);
		py += bls;
	}
	for (i = 0; i < 4; i++) {
		ST7735R_FillRect(min(ST7735R_WIDTH - 1, max(0, x)), min(ST7735R_HEIGHT - 1, max(0, y)), min(ST7735R_WIDTH - 1, max(0, x + bls)), min(ST7735R_HEIGHT - 1, max(0, y + bls)), 0, 0, 255);
		y += bls;
	}
}

void clear_bar(int x, int y) {
	int i;

	for (i = 0; i < 5; i++) {
		ST7735R_FillRect(min(ST7735R_WIDTH - 1, max(0, x)), min(ST7735R_HEIGHT - 1, max(0, y)), min(ST7735R_WIDTH - 1, max(0, x + bls)), min(ST7735R_HEIGHT - 1, max(0, y + bls)), 0, 0, 0);
		y += bls;
	}
}


void curr_piece(int x, int y, int px, int py, int type){
	if (type == 1) {
		bar(x * bls, y * bls, py);
		if (px != x)
			clear_bar(px < x ? (px * bls - 1): (px * bls + 1), py * bls);
	}

}



int main(void)
{
	double axg, ayg, azg, gxds, gyds, gzds;
	int x = ST7735R_WIDTH / bls / 2, y = 0, px, py, type = 1;
	char buffer[100];
	SPI_init();
	ST7735R_Begin();
	mpu6050_init();
	ST7735R_FillRect(0, 0, ST7735R_WIDTH - 1, ST7735R_HEIGHT - 1, 0, 0, 0);
	
	while(1) {

		mpu6050_getConvData(&axg, &ayg, &azg, &gxds, &gyds, &gzds);
		px = x;
		py = y;
		y += SPEED;
		if (axg > 0.3) {
			buffer[0] = 'u';
		} else if (axg < -0.3){
			buffer[0] = 'd';
		}
		buffer[1] = ' ';
		if (ayg > 0.3) {
			buffer[2] = 'r';
			x += SPEED;
		} else if (ayg < -0.3){
			buffer[2] = 'l';
			x -= SPEED;
		}
		buffer[3] = '\0';
		curr_piece(x, y, px, py, 1);
		if (type == 1 && (y + 5) * bls > ST7735R_HEIGHT) {
			x = ST7735R_WIDTH / bls / 2;
			y = 0;
		}
		ST7735R_DrawText(16, 16, buffer, 200, 200, 200,
	                      0, 0, 0);
		_delay_ms(500);
	}

	return 0;
}
